;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; NAME: COMPLETECOINTERRE
;
; PURPOSE: pour colorier proprement les continents! (c''est une longue
; histoire...)
;
; CATEGORY: pour plt
;
; CALLING SEQUENCE: completecointerre
; 
; INPUTS: non
;
; KEYWORD PARAMETERS:  _EXTRA 
;
; OUTPUTS: non
;
; COMMON BLOCKS: common.pro
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; EXAMPLE:
;
; MODIFICATION HISTORY:Sebastien Masson (smasson@lodyc.jussieu.fr)
;                      01/10/1999
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
PRO completecointerre, COINMONTE = coinmonte, COINDESCEND = coindescend, INDICEZOOM = indicezoom $
                       , _extra = ex
@common
;------------------------------------------------------------
   tempsun = systime(1)         ; pour key_performance
;------------------------------------------------------------
; definitions des vecteurs coinmont et coindesc
;------------------------------------------------------------
   if keyword_set(coinmonte) then coinmont = coinmonte $
   ELSE coinmont = cointerremont
   if keyword_set(coindescend) then coindesc = coindescend $
   ELSE coindesc = cointerredesc
;------------------------------------------------------------
; definition descoordonnees des points numerotes 1,2,3,4,5,6 cf. les
; schemas en dessous!
;------------------------------------------------------------
   tempdeux = systime(1)        ; pour key_performance =2
   if coinmont[0] NE -1 OR coindesc[0] NE -1 then BEGIN
      if keyword_set(indicezoom) then begin
         long1 = glamv[indicezoom] & lati1 = gphiv[indicezoom]
         long2 = glamu[indicezoom] & lati2 = gphiu[indicezoom]
         long3 = glamf[indicezoom] & lati3 = gphif[indicezoom]
         taille = size(indicezoom)
         nx = taille[1]
      ENDIF ELSE BEGIN 
         long1 = glamv & lati1 = gphiv
         long2 = glamu & lati2 = gphiu
         long3 = glamf & lati3 = gphif
         nx = jpi
      ENDELSE 
      long4 = long2  & lati4 = lati2
      long5 = long1 & lati5 = lati1
   endif
   IF testvar(var = key_performance) EQ 2 THEN $
    print, 'temps completecointerre: positions des points', systime(1)-tempdeux
;
;
; cas coin terre en montee:
;      2 points terre en diagonale montante avec 2 points mer sur
;      la diagonale descendante.
;
;                     4    
;     t(i+nx)=1    u(i+nx)       t(i+nx+1)=0
;                     |      \
;                     |         \
;         1         3 |            \   5
;       v(i)---------f(i)------------v(i+1)
;           \         |
;              \      |
;                 \   |
;      t(i)=0       2 u(i)          t(i+1)=1
;
;
   if coinmont[0] NE -1 then BEGIN
      tempdeux = systime(1)     ; pour key_performance =2
      for id = 0, n_elements(coinmont)-1 do BEGIN
         i = coinmont[id]
         if long1[i] GE lon1 AND long5[i+1] LE lon2 $
          AND lati2[i] GE lat1 AND lati4[i+nx] LE lat2 then begin
            polyfill, [long1[i], long2[i], long3[i], long4[i+nx], long5[i+1], long3[i]] $
             , [lati1[i], lati2[i], lati3[i], lati4[i+nx], lati5[i+1], lati3[i]] $
             , color = c_cont, _extra = ex
         endif
      endfor
      IF testvar(var = key_performance) EQ 2 THEN $
       print, 'temps completecointerre: trace de cointerremonte', systime(1)-tempdeux
   endif
;------------------------------------------------------------
; cas coin terre en descendante.:
;      2 points terre en diagonale descendante avec 2 points mer sur
;      la diagonale montante
;
;                     4
;     t(i+nx)=1    u(i+nx)       t(i+nx+1)=0
;                /    |       
;             /       |          
;          /        3 |                5
;       v(i)---------f(i)------------v(i+1)
;         1           |            /
;                     |         /
;                     |      /
;      t(i)=0      2 u(i)          t(i+1)=1
;
   if keyword_set(coindescend) then coindesc = coindescend $
   ELSE coindesc = cointerredesc
   if coindesc[0] NE -1 then begin
      tempdeux = systime(1)     ; pour key_performance =2
      for id = 0, n_elements(coindesc)-1 do BEGIN
         i = coindesc[id]
         if long1[i] GE lon1 AND long5[i+1] LE lon2 $
          AND lati2[i] GE lat1 AND lati4[i+nx] LE lat2 then begin
            polyfill, [long1[i], long4[i+nx], long3[i], long2[i], long5[i+1], long3[i]] $
             , [lati1[i], lati4[i+nx], lati3[i], lati2[i], lati5[i+1], lati3[i]] $
             , color = c_cont, _extra = ex
         endif
      endfor
      IF testvar(var = key_performance) EQ 2 THEN $
       print, 'temps completecointerre: trace de cointerredescend', systime(1)-tempdeux
   endif

;------------------------------------------------------------
   IF keyword_set(key_performance) THEN print, 'temps completecointerre', systime(1)-tempsun 
;------------------------------------------------------------
   return
end
